VERSION 5.00
Begin VB.UserControl HotKey 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
End
Attribute VB_Name = "HotKey"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'-------------------------------------------------------------------
' Hotkey Control for defining Hotkeys

' If you want to know how to install hotkeys for any purpose see:
' http://www.freevbcode.com/ShowCode.Asp?ID=987
' Or
' http://www.codearchive.com/~stefan/snip/sniphotkey.htm
'
' If you want to recieve events you have to subclass the m_Handle,
' the Handle of the Hotkey Control.
'
' By Ascher Stefan
' s.ascher@tirol.com
' http://www.codearchive.com/~stefan/
'-------------------------------------------------------------------

'This is everything I wanted, if you want more properties (e.g. custom font, backcolor),
'build it in.

'Make sure that the CommonControls library is loaded
Private Declare Sub InitCommonControls Lib "comctl32.dll" ()

'Create the window
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" _
    (ByVal dwExStyle As Long, ByVal lpClassName As String, _
    ByVal lpWindowName As String, ByVal dwStyle As Long, _
    ByVal x As Long, ByVal y As Long, _
    ByVal nWidth As Long, ByVal nHeight As Long, _
    ByVal hwndParent As Long, ByVal hMenu As Long, _
    ByVal hInstance As Long, lpParam As Any) As Long
    
'Destroy the window
Private Declare Function DestroyWindow Lib "user32" (ByVal hWnd As Long) As Long

'Create the Font
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" _
    (ByVal H As Long, ByVal W As Long, ByVal E As Long, _
    ByVal O As Long, ByVal W As Long, ByVal i As Long, _
    ByVal u As Long, ByVal S As Long, ByVal C As Long, _
    ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, _
    ByVal PAF As Long, ByVal F As String) As Long

'Destroy the Font
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

'Resize the window
Private Declare Function MoveWindow Lib "user32" _
    (ByVal hWnd As Long, ByVal x As Long, _
    ByVal y As Long, ByVal nWidth As Long, _
    ByVal nHeight As Long, ByVal bRepaint As Long) As Long

'Send messages to the created window
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
    (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, _
    lParam As Any) As Long

'window constants
Private Const WS_EX_CLIENTEDGE = &H200&
Private Const WS_BORDER = &H800000
Private Const WS_CHILD = &H40000000
Private Const WS_TABSTOP = &H10000
Private Const WS_VISIBLE = &H10000000
Private Const WS_HOTKEYSTYLE = WS_BORDER Or WS_CHILD Or WS_TABSTOP Or WS_VISIBLE
Private Const WM_SETFONT = &H30
Private Const WM_USER = &H400
'hotkey constants
Private Const HKM_SETHOTKEY = (WM_USER + 1)
Private Const HKM_GETHOTKEY = (WM_USER + 2)
Private Const HKM_SETRULES = (WM_USER + 3)
'font constants
Private Const ANSI_CHARSET = 0
Private Const OUT_DEFAULT_PRECIS = 0

'
Public Enum ModConst
    MOD_ALT = &H1
    MOD_CONTROL = &H2
    MOD_SHIFT = &H4
End Enum

Private Const HOTKEYF_SHIFT = &H1
Private Const HOTKEYF_CONTROL = &H2
Private Const HOTKEYF_ALT = &H4

Private m_Handle As Long

'Handle of the created font
Private hFont As Long

Private Sub UserControl_Initialize()
    InitCommonControls
    
    hFont = CreateFont(-1, 0&, 0&, 0&, 400&, 0&, 0&, 0&, ANSI_CHARSET, OUT_DEFAULT_PRECIS, _
    0&, 0&, 0&, UserControl.Font.Name)
    
    m_Handle = CreateWindowEx(WS_EX_CLIENTEDGE, "msctls_hotkey32", "", _
    WS_HOTKEYSTYLE, 0, _
    0, UserControl.Width / Screen.TwipsPerPixelX, _
    UserControl.Height / Screen.TwipsPerPixelX, _
    UserControl.hWnd, 0, App.hInstance, 0)
    
    'By default the Font is Bold, this makes it normal
    'If you want to choose different fonts at runtime of the control, you can make it
    'in the same way, but I don't need this ;-)
    SendMessage m_Handle, WM_SETFONT, hFont, 0&
    
    
End Sub

Private Sub UserControl_Resize()
    'fit the created window in the usercontrol
    
    MoveWindow m_Handle, 0, 0, UserControl.Width / Screen.TwipsPerPixelX, _
    UserControl.Height / Screen.TwipsPerPixelY, 1
    
End Sub

Public Property Get hWnd() As Long
    'Handle of the created window, not of the usercontrol
    
    hWnd = m_Handle
End Property

Private Sub UserControl_Terminate()
    DeleteObject hFont
    DestroyWindow m_Handle
End Sub

Public Sub SetHotkey(Modifier As Long, Keycode As Long)
    'Set a predefined hotkey
    
'    Debug.Print Modifier
    Modifier = TransformMod(Modifier)
    SendMessage m_Handle, HKM_SETHOTKEY, MakeLong(CInt(Keycode), CInt(Modifier)), 0&
End Sub

Public Sub GetHotkey(pModifier As Long, pKeycode As Long)
    'Get the defined hotkey
    
    Dim wParam As Long
    wParam = SendMessage(m_Handle, HKM_GETHOTKEY, 0&, 0&)
    pModifier = TransformMod(HiWord(wParam))
    pKeycode = LoWord(wParam)
End Sub

Public Property Get Modifier() As Long
    'Get only the modifier
    Dim tmpMod As Long, tmpKey As Long
    GetHotkey tmpMod, tmpKey
    Modifier = tmpMod
End Property

Public Property Get Keycode() As Long
    'Get only the keycode
    Dim tmpMod As Long, tmpKey As Long
    GetHotkey tmpMod, tmpKey
    Keycode = tmpKey

End Property

Private Function TransformMod(Modifier As Long) As Long
    If ((Modifier And MOD_ALT) <> MOD_ALT) Or ((Modifier And MOD_SHIFT) <> MOD_SHIFT) Then
        'The MOD_... and the HOTKEYF_... constants are not the same, so we have to transform it
        
        'it should be possible to find a better way, but i don't want to think ;-)
        
        If (Modifier And MOD_ALT) = MOD_ALT Then
            Modifier = Not MOD_ALT
            Modifier = Modifier And HOTKEYF_ALT
        
        ElseIf (Modifier And MOD_SHIFT) = MOD_SHIFT Then
            Modifier = Not MOD_SHIFT
            Modifier = Modifier And HOTKEYF_SHIFT
        End If
    End If
    TransformMod = Modifier
End Function

Private Function LoWord(ByVal dw As Long) As Integer
    LoWord = dw And &HFF&
End Function

Private Function HiWord(ByVal dw As Long) As Integer
    HiWord = (dw And &HFF00) \ 256
End Function

Private Function MakeLong(LoWord As Integer, HiWord As Integer) As Long
    MakeLong = (HiWord * &H100) + (LoWord And &HFF&)
End Function
